/****************************************************************************
 * This file is part of the project AqHome.
 * AqHome (c) by 2023 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "./moddevice.h"
#include "../utils.h"

#include "aqhome/aqhome.h"
#include "aqhome/msg/msg_node.h"
#include "aqhome/ipc/msg_ipc_result.h"
#include "aqhome/ipc/data/msg_data_devices.h"
#include "aqhome/ipc/data/ipc_data.h"

#include <gwenhywfar/args.h>
#include <gwenhywfar/i18n.h>
#include <gwenhywfar/debug.h>
#include <gwenhywfar/text.h>

#include <time.h>
#include <unistd.h>


#define I18S(msg) msg
#define I18N(msg) GWEN_I18N_Translate(PACKAGE, msg)


static int _doModDevice(GWEN_DB_NODE *dbArgs);
static void _sendCommand(GWEN_MSG_ENDPOINT *epTcp, const AQH_DEVICE *device);




int AQH_Tool_ModDevice(GWEN_DB_NODE *dbGlobalArgs, int argc, char **argv)
{
  GWEN_DB_NODE *dbLocalArgs;
  int rv;
  const GWEN_ARGS args[]= {
    {
      GWEN_ARGS_FLAGS_HAS_ARGUMENT, /* flags */
      GWEN_ArgsType_Char,           /* type */
      "brokerAddress",              /* name */
      0,                            /* minnum */
      1,                            /* maxnum */
      "t",                          /* short option */
      "tcpaddress",                 /* long option */
      I18S("Specify TCP address to connect to (defaults to 127.0.0.1)"),
      I18S("Specify TCP address to connect to (defaults to 127.0.0.1)")
    },
    {
      GWEN_ARGS_FLAGS_HAS_ARGUMENT, /* flags */
      GWEN_ArgsType_Int,            /* type */
      "brokerPort",                 /* name */
      0,                            /* minnum */
      1,                            /* maxnum */
      "P",                          /* short option */
      "tcpport",                    /* long option */
      I18S("Specify the TCP port to listen on"),
      I18S("Specify the TCP port to listen on")
    },
    {
      GWEN_ARGS_FLAGS_HAS_ARGUMENT, /* flags */
      GWEN_ArgsType_Int,            /* type */
      "timeout",                    /* name */
      0,                            /* minnum */
      1,                            /* maxnum */
      "T",                          /* short option */
      NULL,                         /* long option */
      I18S("Specify timeout in seconds for response"),
      I18S("Specify timeout in seconds for response")
    },
    {
      GWEN_ARGS_FLAGS_HAS_ARGUMENT, /* flags */
      GWEN_ArgsType_Char,           /* type */
      "brokerClientId",             /* name */
      0,                            /* minnum */
      1,                            /* maxnum */
      "c",                          /* short option */
      "clientid",                  /* long option */
      I18S("Specify CLIENTID"),
      I18S("Specify CLIENTID")
    },
    {
      GWEN_ARGS_FLAGS_HAS_ARGUMENT, /* flags */
      GWEN_ArgsType_Char,           /* type */
      "userId",                     /* name */
      0,                            /* minnum */
      1,                            /* maxnum */
      "u",                          /* short option */
      "userid",                     /* long option */
      I18S("Specify user id"),
      I18S("Specify user id")
    },
    {
      GWEN_ARGS_FLAGS_HAS_ARGUMENT, /* flags */
      GWEN_ArgsType_Char,           /* type */
      "password",                   /* name */
      0,                            /* minnum */
      1,                            /* maxnum */
      "p",                          /* short option */
      "password",                   /* long option */
      I18S("Specify service password"),
      I18S("Specify service password")
    },
    {
      GWEN_ARGS_FLAGS_HAS_ARGUMENT, /* flags */
      GWEN_ArgsType_Char,           /* type */
      "device",                     /* name */
      1,                            /* minnum */
      1,                            /* maxnum */
      "d",                          /* short option */
      "device",                     /* long option */
      I18S("Specify name of the device to modify"),
      I18S("Specify name of the device to modify")
    },
    {
      GWEN_ARGS_FLAGS_HAS_ARGUMENT, /* flags */
      GWEN_ArgsType_Char,           /* type */
      "roomName",                   /* name */
      0,                            /* minnum */
      1,                            /* maxnum */
      "R",                          /* short option */
      "room",                       /* long option */
      I18S("Specify room for a device"),
      I18S("Specify room for a device")
    },
    {
      GWEN_ARGS_FLAGS_HAS_ARGUMENT, /* flags */
      GWEN_ArgsType_Char,           /* type */
      "nameForGui",                 /* name */
      0,                            /* minnum */
      1,                            /* maxnum */
      "G",                          /* short option */
      "guiname",                    /* long option */
      I18S("Specify GUI name of the device"),
      I18S("Specify GUI name of the device")
    },
    {
      GWEN_ARGS_FLAGS_HAS_ARGUMENT, /* flags */
      GWEN_ArgsType_Char,           /* type */
      "location",                   /* name */
      0,                            /* minnum */
      1,                            /* maxnum */
      "L",                          /* short option */
      "location",                   /* long option */
      I18S("Specify location of the device"),
      I18S("Specify location of the device")
    },
    {
      GWEN_ARGS_FLAGS_HAS_ARGUMENT, /* flags */
      GWEN_ArgsType_Char,           /* type */
      "description",                /* name */
      0,                            /* minnum */
      1,                            /* maxnum */
      NULL,                          /* short option */
      "description",                   /* long option */
      I18S("Specify description for the device"),
      I18S("Specify description for the device")
    },
    {
      GWEN_ARGS_FLAGS_HELP | GWEN_ARGS_FLAGS_LAST, /* flags */
      GWEN_ArgsType_Int,             /* type */
      "help",                       /* name */
      0,                            /* minnum */
      0,                            /* maxnum */
      "h",                          /* short option */
      "help",                       /* long option */
      "Show this help screen",      /* short description */
      "Show this help screen"       /* long description */
    }
  };

  dbLocalArgs=GWEN_DB_GetGroup(dbGlobalArgs, GWEN_DB_FLAGS_DEFAULT, "local");
  rv=GWEN_Args_Check(argc, argv, 1,
                     GWEN_ARGS_MODE_ALLOW_FREEPARAM,
                     args,
                     dbLocalArgs);
  if (rv==GWEN_ARGS_RESULT_ERROR) {
    fprintf(stderr, "ERROR: Could not parse arguments\n");
    return 1;
  }
  else if (rv==GWEN_ARGS_RESULT_HELP) {
    GWEN_BUFFER *ubuf;

    ubuf=GWEN_Buffer_new(0, 1024, 0, 1);
    if (GWEN_Args_Usage(args, ubuf, GWEN_ArgsOutType_Txt)) {
      fprintf(stderr, "ERROR: Could not create help string\n");
      return 1;
    }
    fprintf(stderr, "%s\n", GWEN_Buffer_GetStart(ubuf));
    GWEN_Buffer_free(ubuf);
    return 0;
  }

  AQH_MergeConfigFileIntoConfig(dbLocalArgs, "ConfigFile");

  return _doModDevice(dbLocalArgs);
}



int _doModDevice(GWEN_DB_NODE *dbArgs)
{
  GWEN_MSG_ENDPOINT *epTcp;
  int timeoutInSeconds;
  GWEN_MSG *msg;
  AQH_DEVICE *device;

  timeoutInSeconds=GWEN_DB_GetIntValue(dbArgs, "timeout", 0, 5);
  device=Utils_DeviceFromArgs(dbArgs);

  epTcp=Utils_SetupBrokerClientEndpoint(dbArgs, 0);
  if (epTcp==NULL) {
    DBG_ERROR(NULL, "ERROR creating TCP connection");
    return 2;
  }

  /*fprintf(stdout, "Sending GetValues request\n");*/

  _sendCommand(epTcp, device);

  for (;;) {
    uint16_t code;

    msg=Utils_WaitForSpecificIpcMessage(epTcp, AQH_MSGTYPE_IPC_DATA_RESULT, timeoutInSeconds);
    if (msg==NULL) {
      DBG_ERROR(NULL, "No response received");
      return 2;
    }
    code=GWEN_IpcMsg_GetCode(msg);
    if (code==AQH_MSGTYPE_IPC_DATA_RESULT) {
      uint32_t resultCode;

      resultCode=AQH_ResultIpcMsg_GetResultCode(msg);
      if (resultCode!=AQH_MSG_IPC_SUCCESS) {
        fprintf(stderr, "ERROR: %d\n", resultCode);
        GWEN_MsgEndpoint_free(epTcp);
        return 3;
      }
      break;
    }
    else {
      DBG_INFO(NULL, "Unexpected message \"%d\"", code);
      GWEN_MsgEndpoint_free(epTcp);
      return 3;
    }
  } /* for */

  GWEN_MsgEndpoint_free(epTcp);
  return 0;
}



void _sendCommand(GWEN_MSG_ENDPOINT *epTcp, const AQH_DEVICE *device)
{
  GWEN_MSG *msgOut;

  msgOut=AQH_DevicesDataIpcMsg_newForOneDevice(AQH_MSGTYPE_IPC_DATA_MODDEVICE_REQ, AQH_MSGDATA_DEVICES_FLAGS_LASTMSG, device);
  GWEN_MsgEndpoint_AddSendMessage(epTcp, msgOut);
}






